//////////////////////////////////////////////////////////////////////////////////////////////
// Tarn Adams makes no representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//////////////////////////////////////////////////////////////////////////////////////////////

#include <gl/gl.h>      // OpenGL include
#include <gl/glu.h>     // OpenGL utilty library

#define BIT1 1
#define BIT2 2
#define BIT3 4
#define BIT4 8
#define BIT5 16
#define BIT6 32
#define BIT7 64
#define BIT8 128

//THE BITMAP CLASS
struct bitmap_class
	{
	unsigned int gennum;
	BITMAPINFOHEADER info;
	unsigned char *data;

	bitmap_class(void)
		{
		data=NULL;
		}

	bitmap_class(bitmap_class &source)
		{
		gennum=source.gennum;
		info=source.info;
		data=new unsigned char[source.info.biWidth*source.info.biHeight*4];
		memmove(data,source.data,source.info.biWidth*source.info.biHeight*4);
		}
	};

#define BITMAP_ID   0x4D42    // the universal bitmap ID

unsigned char *LoadBitmapFile(char *filename, BITMAPINFOHEADER *bitmapInfoHeader);
unsigned char *LoadBitmapFileWithAlpha(char *filename, BITMAPINFOHEADER *bitmapInfoHeader);

//FUNCTIONS
void PaintFrame(void);

void printscreen(void);

//GL
BOOL    SetupWindow(const char *title, int width, int height, int bits, bool isFullscreen);
BOOL    KillWindow();

GLvoid  ResizeScene(GLsizei width, GLsizei height);
BOOL    InitializeScene();
BOOL    Cleanup();

RGBTRIPLE rgbt(int r,int g,int b);
unsigned int CreateBitmapFont(char *fontName, int fontSize);
void ClearFont(unsigned int base);
void PrintString(unsigned int base, char *str);

long random(unsigned long r);

long FAR PASCAL WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );